#ifndef __X10_ARRAY_DISTARRAY__LOCALSTATE_H
#define __X10_ARRAY_DISTARRAY__LOCALSTATE_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
#define X10_UTIL_INDEXEDMEMORYCHUNK_H_NODEPS
#include <x10/util/IndexedMemoryChunk.h>
#undef X10_UTIL_INDEXEDMEMORYCHUNK_H_NODEPS
namespace x10 { namespace util { 
template<class TPMGL(T)> class IndexedMemoryChunk;
} } 
namespace x10 { namespace array { 

template<class TPMGL(T34106)> class DistArray__LocalState;
template <> class DistArray__LocalState<void>;
template<class TPMGL(T34106)> class DistArray__LocalState : public x10::lang::Object
  {
    public:
    RTT_H_DECLS_CLASS
    
    x10::util::IndexedMemoryChunk<TPMGL(T34106) > FMGL(data);
    
    void _constructor(x10::util::IndexedMemoryChunk<TPMGL(T34106) > c);
    
    static x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> > _make(
             x10::util::IndexedMemoryChunk<TPMGL(T34106) > c);
    
    virtual x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> >
      x10__array__DistArray__LocalState____x10__array__DistArray__LocalState__this(
      );
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};
template <> class DistArray__LocalState<void> : public x10::lang::Object
{
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_ARRAY_DISTARRAY__LOCALSTATE_H

namespace x10 { namespace array { 
template<class TPMGL(T34106)> class DistArray__LocalState;
} } 

#ifndef X10_ARRAY_DISTARRAY__LOCALSTATE_H_NODEPS
#define X10_ARRAY_DISTARRAY__LOCALSTATE_H_NODEPS
#include <x10/lang/Object.h>
#include <x10/util/IndexedMemoryChunk.h>
#ifndef X10_ARRAY_DISTARRAY__LOCALSTATE_H_GENERICS
#define X10_ARRAY_DISTARRAY__LOCALSTATE_H_GENERICS
#endif // X10_ARRAY_DISTARRAY__LOCALSTATE_H_GENERICS
#ifndef X10_ARRAY_DISTARRAY__LOCALSTATE_H_IMPLEMENTATION
#define X10_ARRAY_DISTARRAY__LOCALSTATE_H_IMPLEMENTATION
#include <x10/array/DistArray__LocalState.h>


//#line 70 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/DistArray.x10": x10.ast.PropertyDecl_c

//#line 71 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/DistArray.x10": x10.ast.X10ConstructorDecl_c
template<class TPMGL(T34106)> void x10::array::DistArray__LocalState<TPMGL(T34106)>::_constructor(
                                x10::util::IndexedMemoryChunk<TPMGL(T34106) > c) {
    
    //#line 71 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/DistArray.x10": x10.ast.X10ConstructorCall_c
    (this)->::x10::lang::Object::_constructor();
    
    //#line 71 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/DistArray.x10": x10.ast.AssignPropertyCall_c
    FMGL(data) = c;
    
}
template<class TPMGL(T34106)> x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> > x10::array::DistArray__LocalState<TPMGL(T34106)>::_make(
                                x10::util::IndexedMemoryChunk<TPMGL(T34106) > c)
{
    x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> > this_ = new (memset(x10aux::alloc<x10::array::DistArray__LocalState<TPMGL(T34106)> >(), 0, sizeof(x10::array::DistArray__LocalState<TPMGL(T34106)>))) x10::array::DistArray__LocalState<TPMGL(T34106)>();
    this_->_constructor(c);
    return this_;
}



//#line 70 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/DistArray.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(T34106)> x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> >
  x10::array::DistArray__LocalState<TPMGL(T34106)>::x10__array__DistArray__LocalState____x10__array__DistArray__LocalState__this(
  ) {
    
    //#line 70 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/DistArray.x10": x10.ast.X10Return_c
    return ((x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> >)this);
    
}
template<class TPMGL(T34106)> const x10aux::serialization_id_t x10::array::DistArray__LocalState<TPMGL(T34106)>::_serialization_id = 
    x10aux::DeserializationDispatcher::addDeserializer(x10::array::DistArray__LocalState<TPMGL(T34106)>::_deserializer, x10aux::CLOSURE_KIND_NOT_ASYNC);

template<class TPMGL(T34106)> void x10::array::DistArray__LocalState<TPMGL(T34106)>::_serialize_body(x10aux::serialization_buffer& buf) {
    x10::lang::Object::_serialize_body(buf);
    buf.write(this->FMGL(data));
    
}

template<class TPMGL(T34106)> x10aux::ref<x10::lang::Reference> x10::array::DistArray__LocalState<TPMGL(T34106)>::_deserializer(x10aux::deserialization_buffer& buf) {
    x10aux::ref<x10::array::DistArray__LocalState<TPMGL(T34106)> > this_ = new (memset(x10aux::alloc<x10::array::DistArray__LocalState<TPMGL(T34106)> >(), 0, sizeof(x10::array::DistArray__LocalState<TPMGL(T34106)>))) x10::array::DistArray__LocalState<TPMGL(T34106)>();
    buf.record_reference(this_);
    this_->_deserialize_body(buf);
    return this_;
}

template<class TPMGL(T34106)> void x10::array::DistArray__LocalState<TPMGL(T34106)>::_deserialize_body(x10aux::deserialization_buffer& buf) {
    x10::lang::Object::_deserialize_body(buf);
    FMGL(data) = buf.read<x10::util::IndexedMemoryChunk<TPMGL(T34106) > >();
}

template<class TPMGL(T34106)> x10aux::RuntimeType x10::array::DistArray__LocalState<TPMGL(T34106)>::rtt;
template<class TPMGL(T34106)> void x10::array::DistArray__LocalState<TPMGL(T34106)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::array::DistArray__LocalState<void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[1] = { x10aux::getRTT<x10::lang::Object>()};
    const x10aux::RuntimeType* params[1] = { x10aux::getRTT<TPMGL(T34106)>()};
    x10aux::RuntimeType::Variance variances[1] = { x10aux::RuntimeType::invariant};
    const char *baseName = "x10.array.DistArray.LocalState";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::class_kind, 1, parents, 1, params, variances);
}
#endif // X10_ARRAY_DISTARRAY__LOCALSTATE_H_IMPLEMENTATION
#endif // __X10_ARRAY_DISTARRAY__LOCALSTATE_H_NODEPS
